//==================================================================
// Licensed Materials - Property of IBM
// (c) Copyright IBM Corp. 2003.  All rights reserved.
//
// US Government Users Restricted Rights - Use, duplication or
// disclosure restricted by GSA ADP Schedule Contract with IBM
// Corp.
//
// DISCLAIMER OF WARRANTIES.  The following [enclosed] code is
// sample code created by IBM Corporation.  This sample code is
// not part of any standard or IBM product and is provided to you
// solely for the purpose of assisting you in the development of
// your applications.  The code is provided "AS IS", without
// warranty of any kind.  IBM shall not be liable for any damages
// arising out of your use of the sample code, even if they have
// been advised of the possibility of such damages.
//==================================================================
//------------------------------------------------
// Javascript Alert and Confirm Messages			|
//------------------------------------------------
// Note: messages with arguments does not support multiple entries with same number.
// This means that if in one message, there are two {0}, only the first one will get replaced.
// Therefore please make sure to assign no duplicate number within one message.

//binder.js
var error_on_propertybinder = "\ub4f1\ub85d \uc815\ubcf4 \ud30c\uc778\ub354 {0}\uc758 \uc624\ub958: {1}";
var invalid_value_OnPropertyBinderChange = "\uc720\ud615 {1}\uc5d0 \ub300\ud574 \uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \uac12 {0}";

//eclass.js
var unable_create_object = "\ubaa8\ub378 \uc5c6\uc774 eobject\ub97c \uc791\uc131\ud560 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";
var name_notexist_model = "{1} \ud074\ub798\uc2a4\uc758 \ubaa8\ub378\uc5d0 {0}\uc774(\uac00) \uc5c6\uc2b5\ub2c8\ub2e4.";
var invalid_value_4type = "\uc720\ud615 {1}\uc5d0 \ub300\ud574 \uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \uac12 {0}.";
var maximum_size_allowed_attribute = "{1} \uc18d\uc131\uc5d0 \ud5c8\uc6a9\ub418\ub294 \ucd5c\ub300 \ud06c\uae30\ub294 {0}\uc785\ub2c8\ub2e4.";
var minimum_size_allowed_attribute = "{1} \uc18d\uc131\uc5d0 \ud5c8\uc6a9\ub418\ub294 \ucd5c\uc18c \ud06c\uae30\ub294 {0}\uc785\ub2c8\ub2e4.";
var maximum_size_allowed_reference = "{1} \ucc38\uc870\uc5d0 \ud5c8\uc6a9\ub418\ub294 \ucd5c\ub300 \ud06c\uae30\ub294 {0}\uc785\ub2c8\ub2e4.";
var minimum_size_allowed_reference = "{1} \ucc38\uc870\uc5d0 \ud5c8\uc6a9\ub418\ub294 \ucd5c\uc18c \ud06c\uae30\ub294 {0}\uc785\ub2c8\ub2e4.";

//eobject.js
var invalid_argument="\uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \uc778\uc218.";
var xml_parse_error = "{0}\ud589, {1} \uc704\uce58\uc758 XML \uc624\ub958 \n\uc18c\uc2a4: {2} \n\uc774\uc720: {3}";
var missing_model = "\ub204\ub77d\ub41c \ubaa8\ub378.";
var reference_missing_inmodel = "\ubaa8\ub378\uc5d0\uc11c {1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c {0} \ucc38\uc870\uac00 \ub204\ub77d\ub418\uc5c8\uc2b5\ub2c8\ub2e4.";
var not_a_reference = "{0}\uc774(\uac00) {1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c \ucc38\uc870\uac00 \uc544\ub2d9\ub2c8\ub2e4.";
var member_missing_inmodel = "\ubaa8\ub378\uc5d0\uc11c {1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c {0} \uba64\ubc84\uac00 \ub204\ub77d\ub418\uc5c8\uc2b5\ub2c8\ub2e4.";
var member_not_eatt_or_eref_inmodel = "{1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c {0} \uba64\ubc84\uac00 \ubaa8\ub378\uc758 eattribute \ub610\ub294 ereference\uac00 \uc544\ub2d9\ub2c8\ub2e4.";
var member__inmodel = "{1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c {0} \uba64\ubc84\uac00 \ubaa8\ub378\uc758 eattribute \ub610\ub294 ereference\uac00 \uc544\ub2d9\ub2c8\ub2e4.";
var reference_not_class = "{1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c {0} \ucc38\uc870\uac00 \ud074\ub798\uc2a4\uac00 \uc544\ub2d9\ub2c8\ub2e4.";
var attribute_not_multivalue_inmodel = "{2} \ud074\ub798\uc2a4\uc758 {1} \uc18d\uc131\uc740 \uc5ec\ub7ec \uac12\uc744 \ud5c8\uc6a9\ud558\uc9c0 \uc54a\uc2b5\ub2c8\ub2e4.";
var class_missing_inmodel = "\ubaa8\ub378\uc5d0\uc11c {1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c {0}\uc774(\uac00) \ub204\ub77d\ub418\uc5c8\uc2b5\ub2c8\ub2e4."
var attributecalculate_missing_indata = "\ub370\uc774\ud130\uc5d0 {0} \uc18d\uc131 \uacc4\uc0b0\uc774 \uc788\uc5b4\uc57c \ud569\ub2c8\ub2e4.";
var unable_create_object = "\ubaa8\ub378 \uc5c6\uc774 {0} \ud2b9\uc131\uc5d0 \ub300\ud55c eobject\ub97c \uc791\uc131\ud560 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";
var invalid_property = "\uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \ud2b9\uc131 {0}";
var invalid_expression = "\uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \ud45c\ud604\uc2dd\uc785\ub2c8\ub2e4: {0}.{1}.";
var property_cant_change = "{0} \ud2b9\uc131\uc740 \ubcc0\uacbd\ud560 \uc218 \uc5c6\ub294 \uc77d\uae30 \uc804\uc6a9 \uc18d\uc131\uc774\uac70\ub098 \uacc4\uc0b0 \uc18d\uc131\uc785\ub2c8\ub2e4."
var root_member_name_missing_error = "\ud6a1\ub2e8 \uadf8\ub798\ud504\uc758 \ub8e8\ud2b8 \uba64\ubc84 \uc774\ub984\uc774 \ub204\ub77d\ub418\uc5c8\uc2b5\ub2c8\ub2e4.";
var ecore_namespace_missing_error = "diffgram\uc744 \uc0dd\uc131\ud558\uae30 \uc704\ud55c Ecore \uc774\ub984 \uacf5\uac04\uc774 \ub204\ub77d\ub418\uc5c8\uc2b5\ub2c8\ub2e4.";
var ereference_list_as_key_error ="{1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c {0} \ucc38\uc870\uc758 \uae30\ubcf8 \ud589\uc218\uac00 1\ubcf4\ub2e4 \ud06c\uba70 \ud0a4\uc758 \uc77c\ubd80\ub85c \uc0ac\uc6a9\ud560 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";
var multivalue_attr_as_key_error ="{1} \ud074\ub798\uc2a4\uc5d0 \ub300\ud55c {0} \uc18d\uc131\uc758 \uae30\ubcf8 \ud589\uc218\uac00 1\ubcf4\ub2e4 \ud06c\uba70 \ud0a4\uc758 \uc77c\ubd80\ub85c \uc0ac\uc6a9\ud560 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";


//ecreator.js
var unable_create_reference_nomodel = "\ubaa8\ub378 \uc5c6\uc774 ereference\ub97c \ucd94\uac00\ud560 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";
var unable_create_reference_noreference = "\ucc38\uc870 \uc815\ubcf4 \uc5c6\uc774 ereferences\ub97c \ucd94\uac00\ud560 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";
var add_attribute_2nullclass = "\ub110 eclass\uc5d0 \uc18d\uc131 \ucd94\uac00\ub97c \uc2dc\ub3c4\ud558\uace0 \uc788\uc2b5\ub2c8\ub2e4.";
var no_attribute_supply = "'{0}' eclass\uc5d0 \uc18d\uc131 \ucd94\uac00\ub97c \uc2dc\ub3c4\ud558\uace0 \uc788\uc9c0\ub9cc \uc18d\uc131\uc744 \uc9c0\uc815\ud558\uc9c0 \uc54a\uc558\uc2b5\ub2c8\ub2e4.";
var add_reference_2nullclass = "\ub110 eclass\uc5d0 ereferences \ucd94\uac00\ub97c \uc2dc\ub3c4\ud558\uace0 \uc788\uc2b5\ub2c8\ub2e4.";
var mismatch_reference_length = "'{0}' eclass\ub294 {1}\uac1c\uc758 \ucc38\uc870\ub97c \uc815\uc758\ud558\ub294\ub370 {2}\uac1c\ub9cc \uc804\ub2ec\ub418\uc5c8\uc2b5\ub2c8\ub2e4.";


//datagridcontrol.js
var error_datagrid_action = "datagrid \uc870\uce58 {0}\uc758 \uc624\ub958: {1}";
var label_delete = "\uc0ad\uc81c";
var label_add_newrow = "\uc0c8 \ud589 \ucd94\uac00...";
var label_previous = "<";
var label_next = ">";
var label_accept = "\ud5c8\uc6a9";
var label_cancel = "\ucde8\uc18c";
var label_symbol = "\uae30\ud638";
var action_datagrid_addrow = "\ud589 \ucd94\uac00";
var action_datagrid_removerow = "\ud589 \uc81c\uac70";
var action_datagrid_buildrow = "\ud589 \ube4c\ub4dc";
var selectColName = "\uc120\ud0dd";
var odcDGImgPrevious = "\uc774\uc804 \ud398\uc774\uc9c0\ub85c \uc774\ub3d9\ud558\ub824\uba74 \ud074\ub9ad\ud558\uc2ed\uc2dc\uc624.";
var odcDGImgFirst = "\uccab \ubc88\uc9f8 \ud398\uc774\uc9c0\ub85c \uc774\ub3d9\ud558\ub824\uba74 \ud074\ub9ad\ud558\uc2ed\uc2dc\uc624.";
var odcDGImgNext = "\ub2e4\uc74c \ud398\uc774\uc9c0\ub85c \uc774\ub3d9\ud558\ub824\uba74 \ud074\ub9ad\ud558\uc2ed\uc2dc\uc624.";
var odcDGImgLast = "\ub9c8\uc9c0\ub9c9 \ud398\uc774\uc9c0\ub85c \uc774\ub3d9\ud558\ub824\uba74 \ud074\ub9ad\ud558\uc2ed\uc2dc\uc624.";
var odcDGImgGo = "\uc0ac\uc6a9\uc790\uac00 \uc9c0\uc815\ud558\ub294 \ud398\uc774\uc9c0\ub85c \uc774\ub3d9\ud558\ub824\uba74 \ud074\ub9ad\ud558\uc2ed\uc2dc\uc624.";
var odcDGSkipToMainContent = "\uc8fc \ucee8\ud150\uce20\ub85c \uac74\ub108\ub6f0\uae30";
var odcDGAscending = "\uc624\ub984\ucc28\uc21c \uc815\ub82c";
var odcDGDescending = "\ub0b4\ub9bc\ucc28\uc21c \uc815\ub82c";
var odcDGNavigationPage = " {0}/{1} \ud398\uc774\uc9c0 ";
var odcDGNavigationJump = " \ub2e4\uc74c \ud398\uc774\uc9c0\ub85c \uac74\ub108\ub6f0\uae30:  ";
var invalid_filter_expression = "\uc0ac\uc6a9\uc790\uac00 \uc9c0\uc815\ud55c {0} \ud45c\ud604\uc2dd\uc740 \uc62c\ubc14\ub974\uc9c0 \uc54a\uc2b5\ub2c8\ub2e4. \uc624\ub958 \uba54\uc2dc\uc9c0\ub294 {1}\uc785\ub2c8\ub2e4.";
var odcdgindexhead = "\ud589 \ubc88\ud638";
var odcDGSelection = "\uc120\ud0dd";
var odcDGImgSelectAll = "\ubaa8\ub450 \uc120\ud0dd";
var odcDGImgUnSelectAll = "\ubaa8\ub450 \uc120\ud0dd \ucde8\uc18c";
var odcDGImgAddRow = "\uc0c8 \ud589 \ucd94\uac00";
var odcDGImgDelRow = "\ud589 \uc0ad\uc81c";
var odcDGImgAcceptRow = "\ud5c8\uc6a9";
var odcDGImgCancelRow = "\ucde8\uc18c";


var action_obfcontrolrender_errormsg = "\uc774 \uc81c\uc5b4\uac00 \ud074\ub77c\uc774\uc5b8\ud2b8\uce21 \ub370\uc774\ud130 \ubaa8\ub378\uc5d0 \ubc14\uc778\ub4dc\ub418\uc9c0 \uc54a\uc558\uac70\ub098 \\ud074\ub77c\uc774\uc5b8\ud2b8\uce21 \ub370\uc774\ud130 \ubaa8\ub378\uc774 \ub110(null)\uc785\ub2c8\ub2e4.";


//currency.js
var add_mismatch_currencycode = "\uc608\uc678: \ub367\uc148\ud558\ub294 \uae08\uc561\uc758 \ud1b5\ud654\uac00 \ub2e4\ub985\ub2c8\ub2e4. \uccab \ubc88\uc9f8 \ud1b5\ud654 \ucf54\ub4dc {0}\uc774(\uac00) \ub450 \ubc88\uc9f8 \ud1b5\ud654 \ucf54\ub4dc {1}\uacfc(\uc640) \ub2e4\ub985\ub2c8\ub2e4.";
var subtract_mismatch_currencycode = "\uc608\uc678: \ube84\uc148\ud558\ub294 \uae08\uc561\uc758 \ud1b5\ud654\uac00 \ub2e4\ub985\ub2c8\ub2e4. \uccab \ubc88\uc9f8 \ud1b5\ud654 \ucf54\ub4dc {0}\uc774(\uac00) \ub450 \ubc88\uc9f8 \ud1b5\ud654 \ucf54\ub4dc {1}\uacfc(\uc640) \ub2e4\ub985\ub2c8\ub2e4.";

//NLSService.js
var invalid_date_format = "\uc0ac\uc6a9 \uac00\ub2a5\ud55c \ub0a0\uc9dc \ud615\uc2dd \uc815\ubcf4\uac00 \uc5c6\uc2b5\ub2c8\ub2e4.";
var invalid_date = "{0} \ub0a0\uc9dc\ub294 \uc0ac\uc6a9\uc790\uac00 \uc120\ud0dd\ud558\ub294 \ud615\uc2dd {1}\uc744(\ub97c) \uae30\ubc18\uc73c\ub85c \ud558\ub294 \uc62c\ubc14\ub978 \ub0a0\uc9dc\uac00 \uc544\ub2d9\ub2c8\ub2e4.";
var invalid_time_format = "\uc0ac\uc6a9 \uac00\ub2a5\ud55c \uc2dc\uac04 \ud615\uc2dd \uc815\ubcf4\uac00 \uc5c6\uc2b5\ub2c8\ub2e4.";
var invalid_time = "{0} \uc2dc\uac04\uc740 \uc0ac\uc6a9\uc790\uac00 \uc120\ud0dd\ud558\ub294 \ud615\uc2dd {1}\uc744(\ub97c) \uae30\ubc18\uc73c\ub85c \ud558\ub294 \uc62c\ubc14\ub978 \uc2dc\uac04\uc774 \uc544\ub2d9\ub2c8\ub2e4.";

//tabbedpanelcontrol.js
var label_tab_previous = "< \uc774\uc804";
var label_tab_next = "\ub2e4\uc74c >";
var label_tab_cancel = "\ucde8\uc18c";
var label_tab_finish = "\uc644\ub8cc";

//detectBrowser.js
var browser_not_support = "\uc0ac\uc6a9 \uc911\uc778 {0} \ube0c\ub77c\uc6b0\uc800\ub294 \uc774 \uc751\uc6a9\ud504\ub85c\uadf8\ub7a8\uc5d0\uc11c \uc9c0\uc6d0\ud558\uc9c0 \uc54a\uc2b5\ub2c8\ub2e4.";

//treeControl.js
var odcTreeimgExpand = "\ud3bc\uce58\ub824\uba74 \ud074\ub9ad\ud558\uc2ed\uc2dc\uc624.";
var odcTreeimgCollapse = "\uc811\uc73c\ub824\uba74 \ud074\ub9ad\ud558\uc2ed\uc2dc\uc624.";
var odcTreeimgFolderOpen = "\uc5f4\ub9b0 \ud3f4\ub354";
var odcTreeimgFolderNormal = "\ub2eb\ud78c \ud3f4\ub354";
var odcTreeimgLeaf = "\ud3f4\ub354";
var odcTreeNoChildErr = "\uc774 \ub178\ub4dc\uc5d0\ub294 \ud558\uc704\uac00 \uc5c6\uc2b5\ub2c8\ub2e4.";

//chart draw variables
var chartdraw_lblPie = "\ud30c\uc774\ud615";
var chartdraw_lblBar = "\ub9c9\ub300\ud615";
var chartdraw_lblLine = "\uc120\ud615";
var chartdraw_tooltipShare = "\uacf5\uc720";
var chartdraw_tooltipSeries = "\uc2dc\ub9ac\uc988";
var chartdraw_tooltipLabel = "\ub808\uc774\ube14";
var chartdraw_tooltipValue = "\uac12";
var chartdraw_msgPieChartError = "\ud30c\uc774\ud615 \ub3c4\ud45c\ub97c \uadf8\ub9b4 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";
var chartdraw_lblShowAll = "\ubaa8\ub4e0 \uc2dc\ub9ac\uc988 \ud45c\uc2dc";
var chartdraw_lblChartType = "\ub3c4\ud45c \uc720\ud615";
var chartdraw_lblSeries = "\uc2dc\ub9ac\uc988";
var no_data_series = "\ub370\uc774\ud130 \uc2dc\ub9ac\uc988\ub97c \uc9c0\uc815\ud558\uc9c0 \uc54a\uc558\uc2b5\ub2c8\ub2e4. \ucd5c\uc18c \ud558\ub098\uc758 \ub370\uc774\ud130 \uc2dc\ub9ac\uc988\ub97c \uadf8\ub798\ud504\uc5d0 \ucd94\uac00\ud558\uc2ed\uc2dc\uc624.";
var no_data_atttribute = "{0} \uc2dc\ub9ac\uc988\uc5d0 \ub300\ud55c \ub370\uc774\ud130 \uc18d\uc131 \uc774\ub984\uc744 \uc9c0\uc815\ud558\uc9c0 \uc54a\uc558\uc2b5\ub2c8\ub2e4. \n\uc774 \uc2dc\ub9ac\uc988\uc5d0 \uc62c\ubc14\ub978 \ub370\uc774\ud130 \uc18d\uc131\uc744 \uc120\ud0dd\ud558\uc2ed\uc2dc\uc624.";
var no_label_attribute = "\ub808\uc774\ube14 \uc18d\uc131\uc744 \uc9c0\uc815\ud558\uc9c0 \uc54a\uc558\uc2b5\ub2c8\ub2e4. \n\uc62c\ubc14\ub978 \ub808\uc774\ube14 \uc18d\uc131\uc744 \uc120\ud0dd\ud558\uc2ed\uc2dc\uc624.";
var no_group_operation_specified= "\ub2e4\uc74c \uc2dc\ub9ac\uc988\uc5d0 \ub300\ud55c \uadf8\ub8f9 \uc5f0\uc0b0\uc744 \uc9c0\uc815\ud558\uc9c0 \uc54a\uc558\uc2b5\ub2c8\ub2e4. \n{0}";
var invalid_group_operation = "{0} \uc2dc\ub9ac\uc988\uc5d0 \uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \uadf8\ub8f9 \uc5f0\uc0b0 {1}\uc744(\ub97c) \uc9c0\uc815\ud588\uc2b5\ub2c8\ub2e4. \n\ud5c8\uc6a9\ub418\ub294 \uadf8\ub8f9 \uc5f0\uc0b0\uc740 SUM, AVG, COUNT, MAX, MIN, FIRST \ubc0f LAST\uc785\ub2c8\ub2e4.";
var invalid_label_attribute = "\uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \ub808\uc774\ube14 \uc18d\uc131\uc785\ub2c8\ub2e4. \n\uc62c\ubc14\ub978 \ub808\uc774\ube14 \uc18d\uc131\uc744 \uc120\ud0dd\ud558\uc2ed\uc2dc\uc624.";
var invalid_data_atttribute = "{0} \uc2dc\ub9ac\uc988\uc5d0 \uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \ub370\uc774\ud130 \uc18d\uc131 \uc774\ub984\uc744 \uc9c0\uc815\ud588\uc2b5\ub2c8\ub2e4. \n\uc774 \uc2dc\ub9ac\uc988\uc5d0 \uc62c\ubc14\ub978 \ub370\uc774\ud130 \uc18d\uc131\uc744 \uc120\ud0dd\ud558\uc2ed\uc2dc\uc624.";
var invalid_series_attribute_data_type = "{0} \uc2dc\ub9ac\uc988\uc758 \uc18d\uc131 \uc774\ub984\uc5d0 \uc62c\ubc14\ub974\uc9c0 \uc54a\uc740 \ub370\uc774\ud130 \uc720\ud615\uc744 \uc9c0\uc815\ud588\uc2b5\ub2c8\ub2e4. \n\uadf8\ub798\ud504\ub294 \uc18d\uc131 \uac12\uc774 \uc22b\uc790 \ub610\ub294 \ub0a0\uc9dc\uc778 \uacbd\uc6b0\uc5d0\ub9cc \uc791\uc131\ud560 \uc218 \uc788\uc2b5\ub2c8\ub2e4.";
var null_data_value = "{0} \uc2dc\ub9ac\uc988\uc5d0 \ub110(null)\uac12\uc774 \ud3ec\ud568\ub429\ub2c8\ub2e4.\n\uadf8\ub798\ud504\ub294 \uc18d\uc131 \uac12\uc5d0 \ub110(null)\uac12\uc774 \ud3ec\ud568\ub418\uc9c0 \uc54a\ub294 \uacbd\uc6b0\uc5d0\ub9cc \uc791\uc131\ud560 \uc218 \uc788\uc2b5\ub2c8\ub2e4.";
var thousands_str = "\ucc9c";
var thousands10_str = "\ub9cc";
var thousands100_str = "\uc2ed\ub9cc";
var millions_str = "\ubc31\ub9cc";
var millions10_str = "\ucc9c\ub9cc";
var millions100_str = "\uc5b5";
var billions_str = "\uc2ed\uc5b5";
var billions10_str = "\ubc31\uc5b5";
var billions100_str = "\ucc9c\uc5b5";

/***** PLEASE DO NOT TRANSLATE THIS -- START *****************/
var Scales = new Array();
Scales = [[100000000000.0, billions100_str] , [10000000000.0, billions10_str] , [1000000000.0, billions_str] , [100000000.0, millions100_str] , [10000000.0, millions10_str],  [1000000.0, millions_str],  [100000.0, thousands100_str] , [10000.0, thousands10_str] , [1000.0, thousands_str] ];
/***** PLEASE DO NOT TRANSLATE THIS -- END ********************/



//mask error variable
var mask_not_matched = "\ubb38\uc790\uc5f4\uc758 \uae38\uc774/\ucee8\ud150\uce20\uac00 \uc801\uc6a9\ub41c \ub9c8\uc2a4\ud06c\uc640 \uc77c\uce58\ud558\uc9c0 \uc54a\uc2b5\ub2c8\ub2e4.";

//webservice
var error_mapping_output = "\uc9c0\uc815\ud55c \ucd9c\ub825 \ub9e4\uac1c\ubcc0\uc218 \ub9f5\ud551 \ud45c\ud604\uc2dd\uc774 \uc62c\ubc14\ub974\uc9c0 \uc54a\uc2b5\ub2c8\ub2e4.";
var no_flash_component = "\ud544\uc694\ud55c \ud50c\ub798\uc2dc \uc7ac\uc0dd\uae30\ub97c \ucc3e\uc744 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";
var error_mapping_input = "\uc9c0\uc815\ud55c \uc785\ub825 \ub9e4\uac1c\ubcc0\uc218 \ub9f5\ud551 \ud45c\ud604\uc2dd\uc774 \uc62c\ubc14\ub974\uc9c0 \uc54a\uc2b5\ub2c8\ub2e4.";
var error_accessing_flash = "\ud544\uc694\ud55c \ud50c\ub798\uc2dc \uc7ac\uc0dd\uae30\ub97c \ucc3e\uc744 \uc218 \uc5c6\uc2b5\ub2c8\ub2e4.";

//progressbar
var start_load_model = "\ub370\uc774\ud130 \ubaa8\ub378 {0} \ub85c\ub4dc \uc2dc\uc791";
var end_load_model = "\ub370\uc774\ud130 \ubaa8\ub378 {0} \ub85c\ub4dc \uc885\ub8cc";
var start_load_instance = "{0} \ubaa8\ub378\uc758 \uc778\uc2a4\ud134\uc2a4 \ub370\uc774\ud130 \ub85c\ub4dc \uc2dc\uc791";
var end_load_instance = "{0} \ubaa8\ub378\uc758 \uc778\uc2a4\ud134\uc2a4 \ub370\uc774\ud130 \ub85c\ub4dc \uc885\ub8cc";
var start_render_control = "{0} \uc81c\uc5b4 \ub80c\ub354\ub9c1 \uc2dc\uc791";
var end_render_control = "{0} \uc81c\uc5b4 \ub80c\ub354\ub9c1 \uc885\ub8cc";
var status_string =  "\uc0c1\ud0dc : ";
var progressbar_header = "\ud398\uc774\uc9c0 \ub85c\ub529";
var tabbed_panel = "\ud0ed \ud328\ub110";
var datagrid = "\ub370\uc774\ud130 \ub208\uae08";
var webservice = "\uc6f9 \uc11c\ube44\uc2a4";
var treeview = "\ud2b8\ub9ac \ubcf4\uae30";
var graphdraw = "\uadf8\ub798\ud504 \uadf8\ub9ac\uae30";
